[**@rxap/remote-method**](../README.md)

***

[@rxap/remote-method](../globals.md) / BaseRemoteMethod

# Class: `abstract` BaseRemoteMethod\<ReturnType, Parameter, Metadata\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:38](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L38)

## Extends

- `BaseDefinition`\<`Metadata`\>

## Extended by

- [`ProxyRemoteMethod`](ProxyRemoteMethod.md)

## Type Parameters

• **ReturnType** = `any`

• **Parameter** = `any`

• **Metadata** *extends* [`BaseRemoteMethodMetadata`](../interfaces/BaseRemoteMethodMetadata.md) = [`BaseRemoteMethodMetadata`](../interfaces/BaseRemoteMethodMetadata.md)

## Constructors

### new BaseRemoteMethod()

> **new BaseRemoteMethod**\<`ReturnType`, `Parameter`, `Metadata`\>(`injector`, `metaData`): [`BaseRemoteMethod`](BaseRemoteMethod.md)\<`ReturnType`, `Parameter`, `Metadata`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:50](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L50)

#### Parameters

##### injector

`null` | `Injector`

##### metaData

`any` = `null`

#### Returns

[`BaseRemoteMethod`](BaseRemoteMethod.md)\<`ReturnType`, `Parameter`, `Metadata`\>

#### Overrides

`BaseDefinition<Metadata>.constructor`

## Properties

### \_\_id

> **\_\_id**: `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:61](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L61)

**`Internal`**

unique internal id

#### Inherited from

`BaseDefinition.__id`

***

### \_initialised

> `protected` **\_initialised**: `boolean` = `false`

Defined in: [packages/angular/definition/src/lib/definition.ts:62](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L62)

#### Inherited from

`BaseDefinition._initialised`

***

### destroyed$

> `readonly` **destroyed$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:48](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L48)

Emits if the data source is destroyed

#### Inherited from

`BaseDefinition.destroyed$`

***

### executed$

> **executed$**: `Subject`\<`ReturnType`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:42](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L42)

***

### executionsInProgress$

> **executionsInProgress$**: `CounterSubject`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:44](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L44)

***

### initialised$

> `readonly` **initialised$**: `undefined` \| `Subject`\<`void`\>

Defined in: [packages/angular/definition/src/lib/definition.ts:52](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L52)

Emits if the data source is initialised

#### Inherited from

`BaseDefinition.initialised$`

***

### injector

> `readonly` **injector**: `Injector`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:46](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L46)

***

### interceptors

> `readonly` **interceptors**: `undefined` \| `Set`\<`Subject`\<`any`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:53](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L53)

#### Inherited from

`BaseDefinition.interceptors`

***

### metadata

> **metadata**: `Metadata`

Defined in: [packages/angular/definition/src/lib/definition.ts:44](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L44)

#### Inherited from

`BaseDefinition.metadata`

***

### destroyed$

> `readonly` `static` **destroyed$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:41](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L41)

Emits when a new Definition instance is initialised

#### Inherited from

`BaseDefinition.destroyed$`

***

### initialised$

> `readonly` `static` **initialised$**: `Subject`\<`BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:35](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L35)

Emits when a new Definition instance is initialised

#### Inherited from

`BaseDefinition.initialised$`

***

### instances

> `readonly` `static` **instances**: `Map`\<`string`, `BaseDefinition`\<`BaseDefinitionMetadata`\>\>

Defined in: [packages/angular/definition/src/lib/definition.ts:27](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L27)

A map of active Definition instances

#### Inherited from

`BaseDefinition.instances`

## Accessors

### id

#### Get Signature

> **get** **id**(): `string`

Defined in: [packages/angular/definition/src/lib/definition.ts:87](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L87)

##### Returns

`string`

#### Inherited from

`BaseDefinition.id`

## Methods

### \_call()

> `abstract` `protected` **\_call**(`parameters`?): `ReturnType` \| `Promise`\<`ReturnType`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:111](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L111)

#### Parameters

##### parameters?

`Parameter`

#### Returns

`ReturnType` \| `Promise`\<`ReturnType`\>

***

### applyMetadata()

> **applyMetadata**(`partialMetadata`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:111](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L111)

#### Parameters

##### partialMetadata

`Partial`\<`Metadata`\>

#### Returns

`void`

#### Inherited from

`BaseDefinition.applyMetadata`

***

### call()

> **call**(`parameters`?): `Promise`\<`ReturnType`\>

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:76](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L76)

#### Parameters

##### parameters?

`Parameter`

#### Returns

`Promise`\<`ReturnType`\>

***

### ~~destroy()~~

> **destroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:118](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L118)

#### Returns

`void`

#### Deprecated

use ngOnDestroy instead

#### Inherited from

`BaseDefinition.destroy`

***

### executed()

> **executed**(`result`): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:86](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L86)

#### Parameters

##### result

`ReturnType`

#### Returns

`void`

***

### getMetadata()

> **getMetadata**(): `null` \| `Metadata`

Defined in: [packages/angular/definition/src/lib/definition.ts:107](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L107)

#### Returns

`null` \| `Metadata`

#### Inherited from

`BaseDefinition.getMetadata`

***

### init()

> **init**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:127](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L127)

#### Returns

`void`

#### Inherited from

`BaseDefinition.init`

***

### ngOnDestroy()

> **ngOnDestroy**(): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:122](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L122)

A callback method that performs custom clean-up, invoked immediately
before a directive, pipe, or service instance is destroyed.

#### Returns

`void`

#### Inherited from

`BaseDefinition.ngOnDestroy`

***

### pauseRefresh()

> **pauseRefresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:92](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L92)

#### Returns

`void`

***

### refresh()

> **refresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:100](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L100)

#### Returns

`void`

***

### resumeRefresh()

> **resumeRefresh**(): `void`

Defined in: [packages/angular/remote-method/src/lib/base.remote-method.ts:96](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/remote-method/src/lib/base.remote-method.ts#L96)

#### Returns

`void`

***

### add()

> `static` **add**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:94](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L94)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

`BaseDefinition.add`

***

### remove()

> `static` **remove**(`definition`): `void`

Defined in: [packages/angular/definition/src/lib/definition.ts:102](https://gitlab.com/rxap/packages/-/blob/9978b20018f781a5952245bfe2db15ab7612611c/packages/angular/definition/src/lib/definition.ts#L102)

#### Parameters

##### definition

`BaseDefinition`

#### Returns

`void`

#### Inherited from

`BaseDefinition.remove`
